/*
 * Click nbfs://nbhost/SystemFileSystem/Templates/Licenses/license-default.txt to change this license
 * Click nbfs://nbhost/SystemFileSystem/Templates/Classes/Class.java to edit this template
 */
package com.jcg;

import java.util.*;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.web.bind.annotation.GetMapping;
import org.springframework.web.bind.annotation.RestController;
import org.springframework.data.domain.Pageable;
import org.springframework.data.elasticsearch.core.SearchHit;
import org.springframework.data.elasticsearch.core.SearchHits;
import org.springframework.web.bind.annotation.RequestParam;
import java.util.stream.Collectors;

/**
 *
 * @author omozegieaziegbe
 */
@RestController
public class ProductController {

    @Autowired
    private ProductService productService;

    @GetMapping("/products-count-by-category")
    public List<Product> getProductsCountByCategory(@RequestParam(defaultValue = "1") int size) {
        SearchHits<Product> searchHits = productService.getProductsCountByCategory(Pageable.ofSize(size))
                .getSearchHits();

        return searchHits.getSearchHits()
                .stream()
                .map(SearchHit::getContent)
                .collect(Collectors.toList());
    }

    @GetMapping("/count-by-category")
    public Map<String, Long> countByCategory() {
        return productService.countByCategory();
    }

}
