/*
 * Click nbfs://nbhost/SystemFileSystem/Templates/Licenses/license-default.txt to change this license
 * Click nbfs://nbhost/SystemFileSystem/Templates/Classes/Class.java to edit this template
 */
package com.jcg;

import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.data.domain.Pageable;
import org.springframework.data.elasticsearch.client.elc.NativeQuery;
import org.springframework.data.elasticsearch.core.ElasticsearchOperations;
import org.springframework.data.elasticsearch.core.SearchHitSupport;
import org.springframework.data.elasticsearch.core.SearchHits;
import org.springframework.data.elasticsearch.core.SearchPage;
import org.springframework.data.elasticsearch.core.query.Query;

import co.elastic.clients.elasticsearch._types.aggregations.Aggregation;
import co.elastic.clients.elasticsearch._types.aggregations.MultiBucketBase;
import org.springframework.stereotype.Service;
import java.util.*;
import java.util.stream.Collectors;
import org.springframework.data.elasticsearch.client.elc.ElasticsearchAggregations;

/**
 *
 * @author omozegieaziegbe
 */
@Service
public class ProductService implements ProductItemRepository {

    @Autowired
    private ElasticsearchOperations elasticsearchOperations;

    @Override
    public SearchPage<Product> getProductsCountByCategory(Pageable pageable) {
        Query query = NativeQuery.builder()
                .withAggregation("category_aggregation",
                        Aggregation.of(b -> b.terms(t -> t.field("category.keyword"))))
                .build();

        SearchHits<Product> response = elasticsearchOperations.search(query, Product.class);
        return SearchHitSupport.searchPageFor(response, pageable);
    }

        public Map<String, Long> countByCategory() {
        Query query = NativeQuery.builder()
                .withAggregation("category_aggregation",
                        Aggregation.of(b -> b.terms(t -> t.field("category.keyword"))))
                .build();

        SearchHits<Product> searchHits = elasticsearchOperations.search(query, Product.class);

        // process the aggregation results
        Map<String, Long> aggregatedData = ((ElasticsearchAggregations) searchHits
                .getAggregations())
                .get("category_aggregation")
                .aggregation()
                .getAggregate()
                .sterms()
                .buckets()
                .array()
                .stream()
                .collect(Collectors.toMap(bucket -> bucket.key().stringValue(), MultiBucketBase::docCount));

        return aggregatedData;
    }
}
