//package com.jcg;
//
//import org.junit.jupiter.api.BeforeEach;
//import org.junit.jupiter.api.Test;
//import org.springframework.beans.factory.annotation.Autowired;
//import org.springframework.boot.test.context.SpringBootTest;
//import java.util.*;
//import org.elasticsearch.search.SearchHits;
//import org.elasticsearch.search.aggregations.Aggregations;
//import org.elasticsearch.search.aggregations.bucket.terms.Terms;
//import static org.junit.jupiter.api.Assertions.assertEquals;
//import static org.junit.jupiter.api.Assertions.assertNotNull;
//import static org.mockito.ArgumentMatchers.any;
//import static org.mockito.ArgumentMatchers.eq;
//import static org.mockito.Mockito.mock;
//import static org.mockito.Mockito.times;
//import static org.mockito.Mockito.verify;
//import static org.mockito.Mockito.when;
//import org.springframework.boot.autoconfigure.data.web.SpringDataWebProperties.Pageable;
//import org.springframework.data.domain.PageRequest;
//import org.springframework.data.elasticsearch.client.elc.NativeQuery;
//import org.springframework.data.elasticsearch.core.AggregationContainer;
//
//@SpringBootTest
//class AggElasticSearchExampleApplicationTests {
//
//    @Test
//    void contextLoads() {
//    }
//
//    @Autowired
//    private ProductItemRepository repository;
//            
//    private static final List<Product>  EXPECTED_ITEMS = List.of(
//      new Product("Electronics", "PC Monitor", 99.99),
//      new Product("Multimedia", "Headphones", 200.00));
//  
//
//    @BeforeEach
//    public void before() {
//        repository.saveAll(EXPECTED_ITEMS);
//    }
//
//   @Test
//    void testGetCategoryAggregations() {
//        // Given
//        Pageable pageable = PageRequest.of(0, 10);
//        SearchHits<Product> searchHitsMock = mock(SearchHits.class);
//
//        // Set up the mock data
//        List<Terms.Bucket> buckets = new ArrayList<>();
//        buckets.add(new Terms.Bucket("Electronics", 5));
//        buckets.add(new Terms.Bucket("Books", 3));
//
//        Terms categoryTerms = new Terms(buckets);
//        AggregationContainer<?> categoryAggregation = mock(AggregationContainer.class);
//        when(categoryAggregation.terms()).thenReturn(categoryTerms);
//
//        Map<String, AggregationContainer<?>> aggregationsMap = Map.of("category_aggregation", categoryAggregation);
//        Aggregations aggregations = new Aggregations(aggregationsMap);
//
//        when(searchHitsMock.getAggregations()).thenReturn(aggregations);
//        when(elasticsearchOperations.search(any(NativeQuery.class), eq(Product.class))).thenReturn(searchHitsMock);
//
//        // When
//        List<CategoryAggregationDTO> result = productService.getCategoryAggregations(pageable);
//
//        // Then
//        assertNotNull(result);
//        assertEquals(2, result.size());
//        assertEquals("Electronics", result.get(0).getCategory());
//        assertEquals(5, result.get(0).getCount());
//        assertEquals("Books", result.get(1).getCategory());
//        assertEquals(3, result.get(1).getCount());
//
//        // Verify that the search method was called
//        verify(elasticsearchOperations, times(1)).search(any(NativeQuery.class), eq(Product.class));
//    }
//
//
//}
